function [Confusion Acc Predict Fit] = OneToRestPLS(TrainData,TrainLabel,TestData,TestLabel,ncomp)

for i = 1:length(unique(TrainLabel))
    BinaryTrainLabel = zeros(length(TrainLabel),1);
    BinaryTestLabel = zeros(length(TestLabel),1);
    idxTrain = (TrainLabel==i);
    idxTest = (TestLabel==i);
    BinaryTrainLabel(idxTrain) = 1;
    BinaryTestLabel(idxTest) = 1;

    [XL,YL,XS,YS,BETA] = plsregress(TrainData,BinaryTrainLabel,ncomp);
    Fit(:,i) = [ones(size(TestData,1),1) TestData]*BETA;
end
[~,Predict] = max(Fit,[],2);
Acc = length(find(Predict==TestLabel))/length(TestLabel);

for j = 1:length(unique(TestLabel))
    for k = 1:length(unique(TestLabel))
        idx = (TestLabel==j);
        Confusion(j,k) = length(find(Predict(idx)==k));
    end
end
Confusion = Confusion./repmat(sum(Confusion,2),1,length(unique(TestLabel)));