function Filters = Filter(Data,Paras,item)

Filters = [];
patches = Img2Patch(Data,Paras);

if strcmp(item.method,'kmeans')
    whitening = 1;
    patches = bsxfun(@rdivide, bsxfun(@minus, patches, mean(patches,2)), sqrt(var(patches,[],2)+10));
    
    if (whitening)
        C = cov(patches);
        Filters.mean = mean(patches);
        [V,D] = eig(C);
        Filters.proj = V * diag(sqrt(1./(diag(D) + 0.1))) * V';
        patches = bsxfun(@minus, patches, Filters.mean) * Filters.proj;
    end
    Filters.centroids = runKmeans(patches, Paras.numMaps, item.iteration);
    showCentroids(Filters.centroids, Paras.kernelH, Paras.kernelW); 
end
