function PatchData = Img2Patch(Data,Paras)

[nSamples,~] = size(Data);
pImgH = floor((Paras.imgH - Paras.kernelH) / Paras.stride) + 1;
pImgW = floor((Paras.imgW - Paras.kernelW) / Paras.stride) + 1;
PatchData = zeros(nSamples * pImgH * pImgW, Paras.kernelH * Paras.kernelW);
tic
for i = 1:nSamples
    Img = reshape(Data(i,:), Paras.imgH, Paras.imgW);
    PatchData((i-1)*(pImgH * pImgW) + 1 : i * (pImgH * pImgW), :) = im2col(Img,[Paras.kernelH, Paras.kernelW])';
end
toc